unit ArrayUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, StdCtrls, Buttons, ExtCtrls, Menus, Grids;

type
  TDataFunct=function (addr:Longint;size:Longint):PChar of object;
  TNameFunct=function (NameLength:Longint):PChar of object;
  TSetDataProc=procedure (addr:Longint;value:PChar;size:longint) of object;
  TArrayInfo=class (TCompInfo)
    Offset,EndAddr:Longint;
    Sign:Boolean;
    Reduced:Boolean;
    StringGrid1:TStringGrid;
    GroupBox1:TGroupBox;
    Base:Integer;
    //
    Binary: TMenuItem;
    Octal: TMenuItem;
    Decimal: TMenuItem;
    Hexadecimal: TMenuItem;
    //
    Unsigned: TMenuItem;
    Signed: TMenuItem;
    //
    DataSize:Longint;
    LineSize:Longint;
    //
    DataFormat1: TMenuItem;
    Byte1: TMenuItem;
    Word1: TMenuItem;
    DWord1: TMenuItem;
    Columns1: TMenuItem;
    N1line1: TMenuItem;
    N2line1: TMenuItem;
    N4line1: TMenuItem;
    N8line1: TMenuItem;
    N16line1: TMenuItem;
    Reduced1: TMenuItem;
    //
    OnGetName: TNameFunct;
    OnGetData: TDataFunct;
    OnSetData: TSetDataProc;
    OnClear  : TSimpleProc;
    OnRandom : TSimpleProc;
    Procedure SetName(s:PChar);
    Procedure SetSign(b:Boolean);
    Procedure SetMemRange(_Start,_End:Longint);
    Procedure SpreadDragDrop;override;
  End;
  TArrayViewer = class(TCompForm)
    PopupMenu1: TPopupMenu;
    Base1: TMenuItem;
    Binary: TMenuItem;
    Octal: TMenuItem;
    Decimal: TMenuItem;
    Hexadecimal: TMenuItem;
    N1: TMenuItem;
    ShortName: TMenuItem;
    LongName: TMenuItem;
    NoneName: TMenuItem;
    Sign1: TMenuItem;
    Unsigned: TMenuItem;
    Signed: TMenuItem;
    Data1: TMenuItem;
    Clear: TMenuItem;
    Randomize1: TMenuItem;
    DataFormat1: TMenuItem;
    Byte1: TMenuItem;
    Word1: TMenuItem;
    DWord1: TMenuItem;
    Columns1: TMenuItem;
    N1line1: TMenuItem;
    N2line1: TMenuItem;
    N4line1: TMenuItem;
    N8line1: TMenuItem;
    N16line1: TMenuItem;
    GroupBox1: TGroupBox;
    StringGrid1: TStringGrid;
    Reduced1: TMenuItem;
    N2: TMenuItem;
    procedure ControlResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BinaryClick(Sender: TObject);
    procedure OctalClick(Sender: TObject);
    procedure DecimalClick(Sender: TObject);
    procedure HexadecimalClick(Sender: TObject);
    procedure NoneNameClick(Sender: TObject);
    procedure ShortNameClick(Sender: TObject);
    procedure LongNameClick(Sender: TObject);
    procedure UnsignedClick(Sender: TObject);
    procedure SignedClick(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ClearClick(Sender: TObject);
    procedure Randomize1Click(Sender: TObject);
    procedure Byte1Click(Sender: TObject);
    procedure Word1Click(Sender: TObject);
    procedure DWord1Click(Sender: TObject);
    procedure N1line1Click(Sender: TObject);
    procedure N2line1Click(Sender: TObject);
    procedure N4line1Click(Sender: TObject);
    procedure N8line1Click(Sender: TObject);
    procedure N16line1Click(Sender: TObject);
    procedure StringGrid1GetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure Reduced1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

procedure TArrayInfo.SetName;
Begin
  GroupBox1.Caption:=' '+StrPas(s)+' ';
  Control.Invalidate;
End;

Procedure TArrayInfo.SetSign(b:boolean);
Begin
  Sign:=b;
  if Sign then Signed.Checked:=true else Unsigned.Checked:=true;
  Control.Invalidate;
End;

Procedure TArrayInfo.SetMemRange(_Start,_End:Longint);
Var i:integer;
Begin
  Offset:=_Start;
  EndAddr:=_End;
  StringGrid1.ColCount:=LineSize+1;
  StringGrid1.DefaultColWidth:=((GroupBox1.Width-4-52) div (LineSize))-1;
  StringGrid1.ColWidths[0]:=52;
  if Assigned(OnGetName) then GroupBox1.Caption:=' '+StrPas(OnGetName(NameLength))+' ';
  i:=(_End-_Start) div DataSize;
  if (i and (LineSize-1)>0) then i:=(i div LineSize)+1 else i:=i div LineSize;
  if Reduced then
  Begin
    //cas o on a une seule ligne:
    StringGrid1.RowCount:=i;
    StringGrid1.FixedRows:=0;
    StringGrid1.Align:=alNone;
    StringGrid1.Left:=0;
    StringGrid1.Top:=0;
    ResizePanel.Visible:=false;
    Control.Height:=(StringGrid1.DefaultRowHeight+1)*i+2;
    Control.Ctl3D:=false;
    if Assigned(OnResize) then OnResize;
  End else
  Begin
    StringGrid1.RowCount:=1+i;
    StringGrid1.FixedRows:=1;
    StringGrid1.Align:=alClient;
    ResizePanel.Visible:=True;
    Control.Ctl3D:=True;
  End;
End;

Procedure TArrayInfo.SpreadDragDrop;
Begin
  StringGrid1.OnStartDrag:=Control.OnStartDrag;
  StringGrid1.OnDragDrop:=Control.OnDragDrop;
  StringGrid1.OnEndDrag:=Control.OnEndDrag;
  StringGrid1.OnDragOver:=Control.OnDragOver;

  GroupBox1.OnStartDrag:=Control.OnStartDrag;
  GroupBox1.OnDragDrop:=Control.OnDragDrop;
  GroupBox1.OnEndDrag:=Control.OnEndDrag;
  GroupBox1.OnDragOver:=Control.OnDragOver;
End;

//******************************************************************************
procedure TArrayViewer.ControlResize(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    StringGrid1.DefaultColWidth:=((GroupBox1.Width-4-52) div (LineSize))-1;
    StringGrid1.ColWidths[0]:=52;
    if StringGrid1.FixedRows=0 then
    Begin
      StringGrid1.Width:=Control.Width;
      StringGrid1.Height:=Control.Height;
    End;
  End;
end;

procedure TArrayViewer.FormCreate(Sender: TObject);
Var P:TArrayInfo;
    t:integer;
begin
  inherited;
  P:=TArrayInfo.Create;
  Control.Tag:=longint(P);
  P.StringGrid1:=StringGrid1;
  P.GroupBox1:=GroupBox1;
  P.Base:=10;
  P.NameLength:=1;
  P.LineSize:=4;
  P.DataSize:=1;
  P.Binary:=Binary;
  P.Octal:=Octal;
  P.Decimal:=Decimal;
  P.Hexadecimal:=Hexadecimal;
  P.ShortName:=ShortName;
  P.LongName:=LongName;
  P.NoneName:=NoneName;
  P.Signed:=Signed;
  P.UnSigned:=UnSigned;
  P.DataFormat1:=DataFormat1;
  P.Byte1:=Byte1;
  P.Word1:=Word1;
  P.DWord1:=DWord1;
  P.Columns1:=Columns1;
  P.N1line1:=N1line1;
  P.N2line1:=N2line1;
  P.N4line1:=N4line1;
  P.N8line1:=N8line1;
  P.N16line1:=N16line1;
  P.Reduced:=false;
  P.Reduced1:=Reduced1;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TArrayViewer.BinaryClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Base:=2;
    Binary.Checked:=True;
    StringGrid1.Invalidate;
  End;
end;

procedure TArrayViewer.OctalClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Base:=8;
    Octal.Checked:=True;
    StringGrid1.Invalidate;
  End;
end;

procedure TArrayViewer.DecimalClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Base:=10;
    Decimal.Checked:=True;
    StringGrid1.Invalidate;
  End;
end;

procedure TArrayViewer.HexadecimalClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Base:=16;
    Hexadecimal.Checked:=True;
    StringGrid1.Invalidate;
  End;
end;

procedure TArrayViewer.NoneNameClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=0;
    NoneName.Checked:=True;
    GroupBox1.Caption:='';
  End;
end;

procedure TArrayViewer.ShortNameClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=1;
    ShortName.Checked:=True;
    if Assigned(OnGetName) then GroupBox1.Caption:=' '+StrPas(OnGetName(NameLength))+' ';
  End;
end;

procedure TArrayViewer.LongNameClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=2;
    LongName.Checked:=True;
    if Assigned(OnGetName) then GroupBox1.Caption:=' '+StrPas(OnGetName(NameLength))+' ';
  End;
end;

procedure TArrayViewer.UnsignedClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Sign:=false;
    Unsigned.Checked:=True;
    Control.Invalidate;
  End;
end;

procedure TArrayViewer.SignedClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Sign:=true;
    Signed.Checked:=True;
    Control.Invalidate;
  End;
end;

procedure TArrayViewer.StringGrid1DrawCell(Sender: TObject; Col,
  Row: Integer; Rect: TRect; State: TGridDrawState);
Var Addr0:Longint;
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    if StringGrid1.FixedRows=0 then Row:=Row+1;
    Addr0:=((Row-1)*LineSize)*DataSize+Offset;
    if (Col=0) and (Row>=1) then StringGrid1.Canvas.TextOut(Rect.Left,Rect.Top,
      Format('%0.8X',[Addr0]));
    if (Row=0) and (col>=1) then StringGrid1.Canvas.TextOut(Rect.Left,Rect.Top,
      Format('%.1X',[col-1]));
    if (Row>0) and (Col>0) and Assigned(OnGetData) then
    Begin
      StringGrid1.Canvas.Pen.Style:=psClear;        
      StringGrid1.Canvas.Brush.Style:=bsSolid;
      StringGrid1.Canvas.Rectangle(Rect.Left,Rect.Top,Rect.Right+1,Rect.Bottom+1);
      StringGrid1.Canvas.TextOut(Rect.Left,Rect.Top,OnGetData( Addr0+(Col-1)*DataSize,DataSize ));
      StringGrid1.Canvas.Pen.Style:=psSolid;
    End;
  End;
end;

procedure TArrayViewer.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

procedure TArrayViewer.ClearClick(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnClear) then OnClear;
  End;
end;

procedure TArrayViewer.Randomize1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnRandom) then OnRandom;
  End;  
end;

procedure TArrayViewer.Byte1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    DataSize:=1;
    Byte1.Checked:=True;
    SetMemRange(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.Word1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    DataSize:=2;
    Word1.Checked:=True;
    SetMemRange(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.DWord1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    DataSize:=4;
    DWord1.Checked:=True;
    SetMemRange(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.N1line1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    LineSize:=1;
    N1Line1.Checked:=True;
    SetMemRAnge(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.N2line1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    LineSize:=2;
    N2Line1.Checked:=True;
    SetMemRAnge(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.N4line1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    LineSize:=4;
    N4Line1.Checked:=True;
    SetMemRAnge(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.N8line1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    LineSize:=8;
    N8Line1.Checked:=True;
    SetMemRAnge(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.N16line1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    LineSize:=16;
    N16Line1.Checked:=True;
    SetMemRAnge(Offset,EndAddr);
  End;
end;

procedure TArrayViewer.StringGrid1GetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
Var Addr0:Longint;
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Addr0:=((ARow-1)*LineSize)*DataSize+Offset;
    Value:=OnGetData( Addr0+(ACol-1)*DataSize,DataSize);
  End;
end;

procedure TArrayViewer.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
Var Addr0:Longint;
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    if not StringGrid1.EditorMode then
    Begin
      Addr0:=((ARow-1)*LineSize)*DataSize+Offset;
      OnSetData(Addr0+(ACol-1)*DataSize,PChar(Value),DataSize);
    End;
  End;  
end;

procedure TArrayViewer.Reduced1Click(Sender: TObject);
begin
  inherited;
  With TArrayInfo(TComponent(Sender).Tag) do
  Begin
    Reduced1.Checked:=not Reduced1.Checked;
    Reduced:=Reduced1.Checked;
    SetMemRAnge(Offset,EndAddr);
  End;  
end;

end.
