unit BoxUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, ExtCtrls, StdCtrls, Buttons, Menus;

type

  TBoxInfo = class(TCompInfo)
  public
    Boxhv:integer;
    Auto_size:boolean;
    NameLength:integer;
    GroupBox: TGroupBox;
    ScrollBox: TScrollBox;
    Horizontal1: TMenuItem;
    Vertical1: TMenuItem;
    AutoSize: TMenuItem;
    //Events
    OnTypeChange : TSimpleProc;
    OnExportToClipboard : TSimpleProc;
    Procedure SetBoxhv(i:integer);
    Procedure SetName(s:PChar);
    Procedure SpreadDragDrop;override;
  End;
  TBox = class(TCompForm)
    GroupBox: TGroupBox;
    ScrollBox: TScrollBox;
    PopupMenu1: TPopupMenu;
    AutoSize: TMenuItem;
    Name1: TMenuItem;
    LongName: TMenuItem;
    ShortName: TMenuItem;
    NoneName: TMenuItem;
    Type1: TMenuItem;
    Horizontal1: TMenuItem;
    Vertical1: TMenuItem;
    Exporttoclipboard1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ControlResize(Sender: TObject);
    procedure AutoSizeClick(Sender: TObject);
    procedure Horizontal1Click(Sender: TObject);
    procedure Vertical1Click(Sender: TObject);
    procedure Exporttoclipboard1Click(Sender: TObject);
    procedure LongNameClick(Sender: TObject);
    procedure ShortNameClick(Sender: TObject);
    procedure NoneNameClick(Sender: TObject);
    procedure GroupBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

implementation

{$R *.DFM}

procedure TBoxInfo.SetBoxhv;
Begin
  Boxhv:=i;
  case Boxhv of
    1:Horizontal1.Checked:=true;
    2:Vertical1.Checked:=true;
  End;
End;

procedure TBoxInfo.SetName;
Begin
  GroupBox.Caption:=StrPas(s);
End;

procedure TBoxInfo.SpreadDragDrop;
Begin
  GroupBox.OnStartDrag:=Control.OnStartDrag;
  GroupBox.OnDragDrop:=Control.OnDragDrop;
  GroupBox.OnEndDrag:=Control.OnEndDrag;
  GroupBox.OnDragOver:=Control.OnDragOver;

  ScrollBox.OnDragDrop:=Control.OnDragDrop;
  ScrollBox.OnEndDrag:=Control.OnEndDrag;
  ScrollBox.OnDragOver:=Control.OnDragOver;
End;

//******************************************************************************

procedure TBox.FormCreate(Sender: TObject);
Var P:TBoxInfo;
    t:integer;
begin
  inherited;
  P:=TBoxInfo.Create;
  Control.Tag:=Longint(P);
  P.ScrollBox:=ScrollBox;
  P.GroupBox:=GroupBox;
  P.Horizontal1:=Horizontal1;
  P.Vertical1:=Vertical1;
  P.AutoSize:=AutoSize;
  P.LongName:=LongName;
  P.ShortName:=ShortName;
  P.NoneName:=NoneName;
  P.Auto_size:=true;
  P.NameLength:=1;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TBox.ControlResize(Sender: TObject);
Var Margin:Integer;
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    if Auto_size then Margin:=0 else Margin:=2;
    ScrollBox.Width:=GroupBox.Width-4-Margin;
    ScrollBox.Height:=GroupBox.Height-17-Margin;
  End;
end;

procedure TBox.AutoSizeClick(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    AutoSize.Checked:=not AutoSize.Checked;
    ResizePanel.Visible:=not AutoSize.Checked;
    Auto_size:=AutoSize.Checked;
    ControlResize(Sender);
    if Assigned(OnTypeChange) then OnTypeChange;
  End;
end;

procedure TBox.Horizontal1Click(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    Horizontal1.Checked:=true;
    Boxhv:=1;
    if Assigned(OnTypeChange) then OnTypeChange;
  End;
end;

procedure TBox.Vertical1Click(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    Vertical1.Checked:=true;
    Boxhv:=2;
    if Assigned(OnTypeChange) then OnTypeChange;
  End;
end;

procedure TBox.Exporttoclipboard1Click(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    if Assigned(OnExportToClipboard) then OnExportToClipboard;
  End;
end;

procedure TBox.NoneNameClick(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=0;
    NoneName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TBox.ShortNameClick(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=1;
    ShortName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TBox.LongNameClick(Sender: TObject);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=2;
    LongName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TBox.GroupBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TBoxInfo(TComponent(Sender).Tag) do
  Begin
    GroupBox.SetFocus;
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

end.
