unit CompFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TSimpleProc=procedure of object;
  TStringProc=procedure (s:PChar) of object;
  TIntProc=procedure (i:Longint) of object;
  TCompInfo = class
    public
    Control:TPanel;
    ResizePanel:TPanel;
    ADC:HDC;
    X0,Y0,LX,LY:Integer;
    NameLength:Integer;
    ShortName: TMenuItem;
    LongName: TMenuItem;
    NoneName: TMenuItem;
    OnUpdate:TSimpleProc;
    OnResize:TSimpleProc;
    Ready:Boolean;
    Constructor Create;
    Procedure SetNameLength(i:integer);virtual;
    Procedure SpreadDragDrop;virtual;
  end;
  TFormClass=class of TCompForm;
  TCompForm = class(TForm)
    Control: TPanel;
    ResizePanel: TPanel;
    procedure ResizePanelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ResizePanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ResizePanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ControlResize(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure DrawCadre(Sender:TObject;Var X,Y:Integer);
    Function ExtractControl(Form:TForm):TPanel;
  end;

  TDimDragObject=class (TDragObject)
      Form:TForm;
    public
      Constructor Create(aForm:TForm);
      function GetDragCursor(Accepted: Boolean; X, Y: Integer): TCursor; override;
  end;

Function CreateNewControl(aclass:TFormClass;aForm:TForm):TPanel;

implementation
//******************************************************************************
//******************************************************************************

{$R *.DFM}
Constructor TCompInfo.Create;
Begin
  inherited;
  OnResize:=nil;
End;

procedure TCompInfo.SetNameLength;
Begin
  NameLength:=i;
  case i of
    0:if (NoneName<>nil) then NoneName.Checked:=true;
    1:if (ShortName<>nil) then ShortName.Checked:=true;
    2:if (LongName<>nil) then LongName.Checked:=true;
  End;
  If Assigned(OnUpdate) then OnUpdate;
End;

Procedure TCompInfo.SpreadDragDrop;
Begin
//
End;

//******************************************************************************

Constructor TDimDragObject.Create(aForm:TForm);
Begin
  Form:=aForm;
End;

Function TDimDragObject.GetDragCursor(Accepted: Boolean; X, Y: Integer): TCursor;
Begin
  Result:=crSizeNWSE;
  Form.Canvas.Moveto(X,Y);
  Form.Canvas.LineTo(X+20,Y+20);
End;

//******************************************************************************

Function CreateNewControl(aclass:TFormClass;aForm:TForm):TPanel;
Begin
  Result:=aclass.Create(nil).ExtractControl(aForm);
End;

//******************************************************************************

Procedure TCompForm.DrawCadre(Sender:TObject;Var X,Y:Integer);
Var P1,P2:TPoint;
Begin
  With TCompInfo(TControl(Sender).Tag) do
  Begin
    P1:=Control.ClientToScreen(Point(0,0));
    P2:=Control.ClientToSCreen(Point(Control.Width+X-X0,Control.Height+Y-Y0));
    MoveToEx(ADC,P1.x,P1.y,nil);
    LineTo(ADC,P1.x,P2.y);
    LineTo(ADC,P2.x,P2.y);
    LineTo(ADC,P2.x,P1.y);
    LineTo(ADC,P1.x,P1.y);
  End;
End;

Function TCompForm.ExtractControl(Form:TForm):TPanel;
var t:integer;
    myControl:TPanel;

  Procedure RecurseRemove(Comp:TWinControl);
  Var t:integer;
  Begin
    for t:=0 to Comp.Controlcount-1 do
    Begin
      Comp.Controls[t].Tag:=mycontrol.Tag;
      RemoveComponent(Comp.Controls[t]);
      Comp.InsertComponent(Comp.Controls[t]);
      if Comp.Controls[t] is TWinControl then
        RecurseRemove(TWinControl(Comp.Controls[t]));
    End;
  End;
begin
  myControl:=Control;
  TCompInfo(mycontrol.Tag).ResizePanel:=ResizePanel;
  RemoveControl(control);
  RemoveComponent(control);
  RecurseRemove(mycontrol);
  if Form<>nil then Form.insertControl(mycontrol);
  TCompInfo(mycontrol.Tag).Control:=mycontrol;
  Result:=mycontrol;
  if (ComponentCount=0) and (ControlCount=0) then Free;

  TCompInfo(mycontrol.Tag).Ready:=true;
End;

procedure TCompForm.ResizePanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TCompInfo(TControl(Sender).Tag) do
  Begin
    if Ready then
    Begin
      if ((Control.Width+X-X0)<ResizePanel.Width) then X:=ResizePanel.Width+X0-Control.Width;
      if ((Control.Height+Y-Y0)<ResizePanel.Height) then Y:=ResizePanel.Height+Y0-Control.Height;
      DrawCadre(Sender,X,Y);
      DrawCadre(Sender,LX,LY);
      LX:=X;
      LY:=Y;
    End;
  End;
end;


procedure TCompForm.ResizePanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var P1,P2:TPoint;
    ParentForm:TWinControl;
begin
  inherited;
  if Button=mbLeft then
  With TCompInfo(TControl(Sender).Tag) do
  Begin
    if Ready then
    begin
      ParentForm:=TWinControl(Control.Parent);
      ADC:=GetDC(0);
      P1:=ParentForm.ClientToScreen(Point(0,0));
      P2:=ParentForm.ClientToSCreen(Point(ParentForm.ClientWidth,ParentForm.ClientHeight));
      IntersectClipRect(ADC,P1.x,P1.y,P2.x,P2.y);
      SetRop2(ADC,R2_Not);
      X0:=X;LX:=X;
      Y0:=Y;LY:=Y;
      DrawCadre(Sender,X,Y);
    End;
  End;
end;

procedure TCompForm.ResizePanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button=mbLeft then
  With TCompInfo(TControl(Sender).Tag) do
  Begin
    if Ready then
    Begin
      DrawCadre(Sender,LX,LY);
      ReleaseDC(0,ADC);
      if ((Control.Width+X-X0)<ResizePanel.Width) then X:=ResizePanel.Width+X0-Control.Width;
      if ((Control.Height+Y-Y0)<ResizePanel.Height) then Y:=ResizePanel.Height+Y0-Control.Height;
      Control.Width:=Control.Width+X-X0;
      Control.Height:=Control.Height+Y-Y0;
      if Assigned(OnResize) then OnResize;
    End;
  End;
end;

procedure TCompForm.ControlResize(Sender: TObject);
begin
  inherited;
  With TCompInfo(TControl(Sender).Tag) do
  Begin
    if Ready then
    Begin
      ResizePanel.Top:=Control.Height-ResizePanel.Height;
      ResizePanel.Left:=Control.Width-ResizePanel.Width;
    End;
  End;
end;

end.
