unit RealUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CompFormUnit, ExtCtrls, StdCtrls, Buttons, Menus, StringEditUnit;

type
  TRealInfo=class (TCompInfo)
    Label2,Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    //
    ModifDialog : TForm;
    //
    OnChange: TStringProc;
    Procedure SetName(s:PChar);
    Procedure SetValue(s:PChar);
    Procedure SpreadDragDrop;override;
  End;
  TRealViewer = class(TCompForm)
    Label2: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    Name1: TMenuItem;
    LongName: TMenuItem;
    ShortName: TMenuItem;
    NoneName: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure LongNameClick(Sender: TObject);
    procedure ShortNameClick(Sender: TObject);
    procedure NoneNameClick(Sender: TObject);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


implementation

{$R *.DFM}

procedure TRealInfo.SetName;
Begin
  Label2.Caption:=StrPas(s);
  Control.Invalidate;
End;

procedure TRealInfo.SetValue;
Begin
  Label1.Caption:=StrPas(s);
  Control.Invalidate;
End;

Procedure TRealInfo.SpreadDragDrop;
Begin
  Label1.OnStartDrag:=Control.OnStartDrag;
  Label1.OnDragDrop:=Control.OnDragDrop;
  Label1.OnEndDrag:=Control.OnEndDrag;
  Label1.OnDragOver:=Control.OnDragOver;

  Label2.OnStartDrag:=Control.OnStartDrag;
  Label2.OnDragDrop:=Control.OnDragDrop;
  Label2.OnEndDrag:=Control.OnEndDrag;
  Label2.OnDragOver:=Control.OnDragOver;

  Panel2.OnStartDrag:=Control.OnStartDrag;
  Panel2.OnDragDrop:=Control.OnDragDrop;
  Panel2.OnEndDrag:=Control.OnEndDrag;
  Panel2.OnDragOver:=Control.OnDragOver;
End;

//******************************************************************************

procedure TRealViewer.FormCreate(Sender: TObject);
Var P:TRealInfo;
    t:integer;
begin
  inherited;
  P:=TRealInfo.Create;
  Control.Tag:=longint(P);
  P.Label1:=Label1;
  P.Label2:=Label2;
  P.Panel1:=Panel1;
  P.Panel2:=Panel2;
  P.BitBtn1:=BitBtn1;
  P.NameLength:=1;
  P.ShortName:=ShortName;
  P.LongName:=LongName;
  P.NoneName:=NoneName;
  for t:=0 to Componentcount-1 do
      Components[t].Tag:=longint(P);
end;

procedure TRealViewer.NoneNameClick(Sender: TObject);
begin
  inherited;
  With TRealInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=0;
    NoneName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TRealViewer.ShortNameClick(Sender: TObject);
begin
  inherited;
  With TRealInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=1;
    ShortName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TRealViewer.LongNameClick(Sender: TObject);
begin
  inherited;
  With TRealInfo(TComponent(Sender).Tag) do
  Begin
    NameLength:=2;
    LongName.Checked:=True;
    If Assigned(OnUpdate) then OnUpdate;
  End;
end;

procedure TRealViewer.Label2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  With TRealInfo(TComponent(Sender).Tag) do
  Begin
    BitBtn1.SetFocus;
    if Assigned(Control.OnMouseDown) then
      Control.OnMouseDown(Sender,Button,Shift,X,Y);
  End;
end;

procedure TRealViewer.BitBtn1Click(Sender: TObject);
begin
  inherited;
  With TRealInfo(TComponent(Sender).Tag) do
  Begin
    if ModifDialog=nil then
    Begin
      ModifDialog:=TStringEdit.Create(nil);
      TStringEdit(ModifDialog).OnValidate:=OnChange;
    End;
    TStringEdit(ModifDialog).Caption:='Modify '+Label2.Caption;
    TStringEdit(ModifDialog).VarEdit.Text:=Label1.Caption;
    ModifDialog.Show;
    ModifDialog.SetFocus;
  End;
end;

end.
